//absrctc.cpp
//Example of using abstract class served as base for polymorphism

#include <iostream.h>

class shape { public:                     //abstract class
					virtual float area() = 0; //pure virtual function
				};

class circle : public shape
				{ public:
					circle(float radius)
					 { r = radius; }
					float area()
					 { return 3.1415 * r*r;  }
				  protected:
						float r;
				 };

class rectangle : public circle
				 { public:
					 rectangle(float radius, float height) : circle( radius )
						{ w = 2*r; h = height; }
					 float area( )
						{ return w*h; }
					protected:
						float w, h;
				 };

class antiArch : public rectangle
			{ public:
				antiArch(float radius, float height) : rectangle(radius, height)
					 { }

				float area( )
					 { return rectangle::area() - 0.5*circle::area(); }
			};

 void main(void)
  { shape* ptr[3];     //abstract class serves as pointer only for polymorphism

	 circle cir(5.5);
	 rectangle rec( 4.5, 9.8);
	 antiArch antiArc(8.8, 9.9);

	 ptr[0] = &cir;
	 ptr[1] = &rec;
	 ptr[2] = &antiArc;

	 cout << "Areas of 3 objects: " << endl;
	 for(int i = 0; i < 3; i++)  //polymorphic mamager
	  cout << ptr[i]->area() << endl;
	}

/*the following is the output of this program:
Areas of 3 objects:
95.0304
88.2
52.6011   			*/
