// virtper2.cpp
// virtual functions and dynamic linked list

#include <iostream.h>
enum boolean { false, true };

class person                         // person class
		  {
		  protected:
			 char name[40];
		  public:
			 void setName()
				{ cout << "   Enter name: "; cin >> name; }
			 void getName()
				{ cout << "Name is: " << name << endl; }
			 virtual void setData() = 0;           // pure virtual func
			 virtual void getData() = 0;
			 virtual boolean isOutstanding() = 0;  // pure virtual func
		  };

class student : public person        // student class
		  {
		  private:
			 float gpa;              // grade point average
		  public:
			 void setData()          // get student data from user
				{
				 person::setName();
				 cout << "   Enter student's GPA: "; cin >> gpa;
				}
			 void getData()
				{
				 person::getName();
				 cout << "The person is a student..." << endl;
				}
			 boolean isOutstanding()
				{ return (gpa > 3.5) ? true : false; }
		  };

class professor : public person      // professor class
		  {
			 private:
			  int numPubs;             // number of papers published
			 public:
			  void setData()           // get professor data from user
				{
				 person::setName();
				 cout << "   Enter number of professor's publications: ";
				 cin >> numPubs;
				}
			  void getData()
				{
				 person::getName();
				}

			  boolean isOutstanding()
				{ return (numPubs > 100) ? true : false; }
		  };

 struct list {
		  person* persPtr;
		  list* next;
		  };

void main(void)
		  {
		  list *header, *temptr;     // list of pointers to persons
		  char choice;
		  person* persPtr;
		  student* stuPtr;
		  professor* proPtr;

		  header = NULL;          //initialize

		  do
			{
			 cout << "Enter student or professor (s/p): ";
			 cin >> choice;
			 if(choice=='s')
			  {
				stuPtr = new student;      //make a new student
				stuPtr->setData();         //set student name
				temptr = new list;         //make a new node
				temptr->next = NULL;       //next to NULL
				temptr->persPtr = stuPtr;  //persPtr holds stuPtr
			  }
			 else
			  {
				proPtr = new professor;     //name a new professor
				proPtr->setData();         //set professor name

				temptr= new list;          //make a new node
				temptr->next = NULL;       //next to NULL
				temptr->persPtr = proPtr;  //persPtr holds proPtr
			  }

			 temptr->next = header;        //make link, let next to header
			 header = temptr;              //make a new header

			 cout << "   Enter another (y/n)? ";  // do another person?
			 cin >> choice;
		  }  while( choice=='y' );            // cycle until not 'y'

					 temptr = header;             //make temp header to walk through
					 while(temptr != NULL)        //print names of all
			{                                //persons, and professors
			temptr->persPtr->getData();      //get data from either one
			if( temptr->persPtr->isOutstanding()==true )
					  cout << "   This person is outstanding\n";
			temptr = temptr->next;          //to next node in the list
			}
		  }  // end main()

/*The following are typical output of the program:
Enter student or professor (s/p): s
		  Enter name: Charles
        Enter student's GPA: 3.45
        Enter another (y/n)? y
Enter student or professor (s/p): p
        Enter name: Johnson
        Enter number of professor's publications: 89
        Enter another (y/n)? y
Enter student or professor (s/p): p
        Enter name: Smith
        Enter number of professor's publications: 102
        Enter another (y/n)? y
Enter student or professor (s/p): s
        Enter name: King
        Enter student's GPA: 2.89
        Enter another (y/n)? y
Enter student or professor (s/p): s
        Enter name: Wong
        Enter student's GPA: 3.89
        Enter another (y/n)? n
Name is: Wong
The person is a student...
        This person is outstanding
Name is: King
The person is a student...
Name is: Smith
        This person is outstanding
Name is: Johnson
Name is: Charles
The person is a student...
*/

