// virtufax.cpp  Example of virtual function and polymorphism

#include <iostream.h>
#include <string.h>
#include <stdlib.h>

class Fax {
  public:
			Fax(int);   //constructor to iniialize number of papers in the machine
			void virtual process(int);  // define virtual function
  protected:
		  char phone_num[32];
		  int num_paper;
 };

Fax::Fax(int paper)
 { num_paper = paper; }

void Fax::process(int pages)
 {cout << "Total pages: " << pages << endl;
  cout << "This is virtual processing.." << endl;
 }

class Fax_machine: public Fax{
  public:
			Fax_machine(char* phone, int paper) : Fax(paper)
			 {strcpy(phone_num, phone); }
			void process(int);
};

void Fax_machine::process(int paper)
 {      if (paper > num_paper)
			{cout << endl << "fax is not completed!" << endl;
			 cout << "not enough paper! Please add at least " << (paper-num_paper)
					<< " in the machine.  Thank you." << endl;
			 exit(1);
			}
		  else
			{cout << endl <<"fax is done! " << endl;
			 cout << "The number dialed: " << phone_num << endl;
			 cout << "The total number of pages faxed: " << paper << endl;
			}
 }

class Printer: public Fax{
  public:
			Printer(int paper) : Fax(paper) { };
			void process(int);
};

void Printer::process(int paper)
 { if (paper > num_paper)
			{cout << endl << "printing job is not completed!" << endl;
			 cout << "not enough paper! Please add at least " << (paper-num_paper)
					<< " in the machine.  Thank you." << endl;
			 exit(1);
			}
		  else
			{cout << endl << "printing is done! " << endl;
			 cout << "The total number of pages printed: " << paper << endl;
			}
 }

void main(void)
 {       Fax_machine fax("324-8890", 100);
			Printer printer(30);

			Fax* use;              //pointer to the base

			use = &fax;
			use->process(9);

			use = &printer;
			use->process(40);
 }

/* The following are output of the program:
fax is done!
The number dialed: 324-8890
The total number of pages faxed: 9

printing job is not completed!
not enough paper! Please add at least 10 in the machine.  Thank you.
*/

