// Handout: virtpers.cpp virtual functions with array implementation

#include <iostream.h>
//enum boolean { false, true };

class person                         // person class
 { protected:
	  char name[40];
	public:
	  void setName()
			 { cout << "   Enter name: "; cin >> name; }
	  void getName()
			 { cout << "Name is: " << name << endl; }
	  virtual void setData() = 0;           // pure virtual func
	  virtual bool isOutstanding() = 0;  // pure virtual func
 };

class student : public person        // student class
 { private:
		 float gpa;              // grade point average
	public:
		 void setData()          	// set student data from user
				{ person::setName(); //set student name
				  setGpa();          //set GPA
				}

		 void setGpa()
				{ cout << "   Enter student's GPA: "; cin >> gpa;  }

		 bool isOutstanding()
				{ return (gpa > 3.5) ? true : false; }
  };

class professor : public person      // professor class
 { private:
		int numPubs;             	// number of papers published
	public:
		void setData()           	// set professor data from user
			  { person::setName();  // set professor name
				 setPubs();				//  set publications data
			  }
		void setPubs()
			  { cout << "   Enter number of professor's publications: ";
				 cin >> numPubs;
			  }
		bool isOutstanding()
			  { return (numPubs > 100) ? true : false; }
 };

void main(void)
 { person* persPtr[100];     // list of pointers to persons
	int n = 0;                // number of persons on list
	char choice;

		  do{cout << "Enter student or professor (s/p): ";
					 cin >> choice;
					 if(choice=='s')                  // put new student
						persPtr[n] = new student;     //    in array
					 else                             // put new professor
					  persPtr[n] = new professor;   //    in array
					 persPtr[n++]->setData();         // get data for person
					 cout << "   Enter another (y/n)? ";  // do another person?
					 cin >> choice;
			 } while( choice=='y' );         // cycle until not 'y'

		  for(int j=0; j<n; j++)           // print names of all persons, and
			{ persPtr[j]->getName();        // say if outstanding
			 if( persPtr[j]->isOutstanding()==true )
					  cout << "   This person is outstanding\n";
			}
  }  // end main()

/* The following are typical output of the program:
Enter student or professor (s/p): s
		  Enter name: Charles
		  Enter student's GPA: 3.45
        Enter another (y/n)? y
Enter student or professor (s/p): p
   Enter name: Smith
   Enter number of professor's publications: 99
   Enter another (y/n)? y
Enter student or professor (s/p): p
   Enter name: Johnson
   Enter number of professor's publications: 120
   Enter another (y/n)? y
Enter student or professor (s/p): s
   Enter name: Wong
   Enter student's GPA: 3.89
   Enter another (y/n)? n
Name is: Charles
Name is: Smith
Name is: Johnson
   This person is outstanding
Name is: Wong
   This person is outstanding
*/